package edu.kufpg.bluetooth.server;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.bluetooth.DataElement;
import javax.bluetooth.DeviceClass;
import javax.bluetooth.DiscoveryAgent;
import javax.bluetooth.DiscoveryListener;
import javax.bluetooth.LocalDevice;
import javax.bluetooth.RemoteDevice;
import javax.bluetooth.ServiceRecord;
import javax.bluetooth.UUID;
import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;
import javax.obex.ClientSession;
import javax.obex.HeaderSet;
import javax.obex.Operation;
import javax.obex.ResponseCodes;


public class MyDiscoveryListener implements DiscoveryListener{
    
    private static Object lock=new Object();
    public ArrayList<RemoteDevice> devices;
    
    public MyDiscoveryListener() {
        devices = new ArrayList<RemoteDevice>();
    }
    


    @Override
    public void deviceDiscovered(RemoteDevice btDevice, DeviceClass arg1) {
        String name;
        try {
            name = btDevice.getFriendlyName(false);
        } catch (Exception e) {
            name = btDevice.getBluetoothAddress();
        }
        
        devices.add(btDevice);
        System.out.println("device found: " + name);
        
    }

    @Override
    public void inquiryCompleted(int arg0) {
        synchronized(lock){
            lock.notify();
        }
    }

   
    @Override
    public void serviceSearchCompleted(int arg0, int arg1) {
        synchronized (lock) {
            lock.notify();
        }
    }

    @Override
    public void servicesDiscovered(int transID, ServiceRecord[] servRecord) {
    	System.out.println("hey ! " + servRecord);
    	for(ServiceRecord s : servRecord) {
    		System.out.println("-------"+ s + "-------");
    	}
    	serviceRecords.addAll(Arrays.asList(servRecord));
       // for (int i = 0; i < servRecord.length; i++) {
          //  String url = servRecord[i].getConnectionURL(ServiceRecord.NOAUTHENTICATE_NOENCRYPT, false);
          //  if (url == null) {
            //    continue;
          //  }
          
          /*
        int i=0;
    	System.out.println("enter the device number \n");
    	BufferedReader br = new BufferedReader( new InputStreamReader(System.in));
    	try {
			String s = br.readLine();
            i = Integer.parseInt(s);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
          
          String url = servRecord[i].getConnectionURL(ServiceRecord.NOAUTHENTICATE_NOENCRYPT, false);
            DataElement serviceName = servRecord[i].getAttributeValue(0x0100);
            if (serviceName != null) {
                System.out.println("service " + serviceName.getValue() + " found " + url);
                
                //if(serviceName.getValue().equals("OBEX Object Push")){
                   if(true){
                    sendMessageToDevice(url);                
                }
            } else {
                System.out.println("service found " + url);
            }
            */
          
       // }
    }
    
    private static void sendMessageToDevice(String serverURL){
    	// TO DO
    }

    static DiscoveryListener listener = new MyDiscoveryListener();
    final static List<ServiceRecord> serviceRecords = new ArrayList<ServiceRecord>();
    final static List<BluetoothConnection> connections = new ArrayList<BluetoothConnection>();
    
    /******************MAIN********************/
    
    public static void main(String[] args) {
        
        try{
        	UUID serialPortUuid = new UUID(BluetoothServiceUuids.SERIAL_PORT.getHexValue());
    		UUID[] desiredServiceUuids = new UUID[] { serialPortUuid };
            LocalDevice localDevice = LocalDevice.getLocalDevice();
            DiscoveryAgent agent = localDevice.getDiscoveryAgent();
            RemoteDevice[] devices = agent.retrieveDevices(DiscoveryAgent.PREKNOWN);
            for(RemoteDevice d : devices) {
            	if(d.getBluetoothAddress().equals("201611073171")) {
            		System.out.println("Thingz trouv");
            		synchronized(lock) {
        				int result = agent.searchServices(null, desiredServiceUuids, d, listener);
        				if( DiscoveryListener.SERVICE_SEARCH_DEVICE_NOT_REACHABLE == result) {
        					System.out.println(" but it could not be reached");
        					continue;
        				}
        				lock.wait();
        				
        				
        				System.out.println("service records found");
        				
        				if(null != serviceRecords && serviceRecords.size() > 0) {
        					System.out.println("YA DES SERVICES");
        					for(ServiceRecord serviceRecord: serviceRecords) {
        						String connectionUrl = serviceRecord.getConnectionURL(ServiceRecord.NOAUTHENTICATE_NOENCRYPT, false); // I have no idea what these args are
        						StreamConnection connection;
        						try {
        							connection = (StreamConnection)Connector.open(connectionUrl);
        							DataInputStream inputStream = new DataInputStream(connection.openDataInputStream());
        							BluetoothConnection bluetoothConnection = new BluetoothConnection(d.getBluetoothAddress(), inputStream);
        							bluetoothConnection.setOutputStream(new DataOutputStream(connection.openOutputStream()));
        							connections.add(bluetoothConnection);
        							System.out.println("Connected to " + d.getBluetoothAddress());
        						} catch (IOException e) {
        							System.out.println("Could not connect to " + d.getBluetoothAddress() + ": " + e.getMessage());
        							e.printStackTrace();
        						}
        					}
        				}
        			}
            	}
            }
            
            if(connections.size() > 0) { // we are connected
            	System.out.println("start");
            	BluetoothStreamParseThread t = new BluetoothStreamParseThread(connections.get(0));
            	t.start();
            }
          } catch (Exception e) {
            e.printStackTrace();
        }
        
        
    }  
    
}